//package eu.eudat.model.builder.filetransformer;
//
//import eu.eudat.authorization.AuthorizationFlags;
//import eu.eudat.commons.enums.IsActive;
//import eu.eudat.convention.ConventionService;
//import eu.eudat.data.DmpUserEntity;
//import eu.eudat.data.UserEntity;
//import eu.eudat.file.transformer.enums.DmpUserRole;
//import eu.eudat.file.transformer.models.dmp.DmpUserFileTransformerModel;
//import eu.eudat.file.transformer.models.user.UserFileTransformerModel;
//import eu.eudat.query.UserQuery;
//import gr.cite.tools.data.builder.BuilderFactory;
//import gr.cite.tools.data.query.QueryFactory;
//import gr.cite.tools.exception.MyApplicationException;
//import gr.cite.tools.logging.LoggerService;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.config.ConfigurableBeanFactory;
//import org.springframework.context.annotation.Scope;
//import org.springframework.stereotype.Component;
//
//import java.util.*;
//import java.util.stream.Collectors;
//
//@Component
//@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
//public class DmpUserFileTransformerBuilder extends BaseFileTransformerBuilder<DmpUserFileTransformerModel, DmpUserEntity> {
//
//    private final BuilderFactory builderFactory;
//
//    private final QueryFactory queryFactory;
//
//    private EnumSet<AuthorizationFlags> authorize = EnumSet.of(AuthorizationFlags.None);
//
//    @Autowired
//    public DmpUserFileTransformerBuilder(
//            ConventionService conventionService,
//            BuilderFactory builderFactory, QueryFactory queryFactory) {
//        super(conventionService, new LoggerService(LoggerFactory.getLogger(DmpUserFileTransformerBuilder.class)));
//        this.builderFactory = builderFactory;
//        this.queryFactory = queryFactory;
//    }
//
//    public DmpUserFileTransformerBuilder authorize(EnumSet<AuthorizationFlags> values) {
//        this.authorize = values;
//        return this;
//    }
//
//    @Override
//    protected List<FileTransformerBuilderItemResponse<DmpUserFileTransformerModel, DmpUserEntity>> buildInternal(List<DmpUserEntity> data) throws MyApplicationException {
//        this.logger.debug("building for {} items ", Optional.ofNullable(data).map(List::size).orElse(0));
//        if (data == null)
//            return new ArrayList<>();
//
//
//        Map<UUID, UserFileTransformerModel> userItemsMap = this.collectUsers(data);
//
//        List<FileTransformerBuilderItemResponse<DmpUserFileTransformerModel, DmpUserEntity>> models = new ArrayList<>();
//        for (DmpUserEntity d : data) {
//            DmpUserFileTransformerModel m = new DmpUserFileTransformerModel();
//            m.setId(d.getId());
//            switch (d.getRole()){
//                case User -> m.setRole(DmpUserRole.User);
//                case Owner -> m.setRole(DmpUserRole.Owner);
//                default -> throw new MyApplicationException("unrecognized type " + d.getRole().getValue());
//            }
//            if (userItemsMap != null && userItemsMap.containsKey(d.getUserId())) m.setUser(userItemsMap.get(d.getUserId()));
//            models.add(new FileTransformerBuilderItemResponse<>(m, d));
//        }
//        this.logger.debug("build {} items", Optional.of(models).map(List::size).orElse(0));
//        return models;
//    }
//
//    private Map<UUID, UserFileTransformerModel> collectUsers(List<DmpUserEntity> data) throws MyApplicationException {
//        if (data.isEmpty())
//            return null;
//        this.logger.debug("checking related - {}", UserFileTransformerModel.class.getSimpleName());
//
//        Map<UUID, UserFileTransformerModel> itemMap;
//        UserQuery q = this.queryFactory.query(UserQuery.class).isActive(IsActive.Active).authorize(this.authorize).ids(data.stream().map(DmpUserEntity::getUserId).distinct().collect(Collectors.toList()));
//        itemMap = this.builderFactory.builder(UserFileTransformerBuilder.class).authorize(this.authorize).asForeignKey(q, UserEntity::getId);
//        return itemMap;
//    }
//
//}
